ents = {}
ents.objects = {}
ents.objpath = "entities/"
local register = {}
id = 0

function ents.Startup()
	register["tree"] = love.filesystem.load(ents.objpath .. "tree.lua")
	register["eli"] = love.filesystem.load(ents.objpath .. "eli.lua")
end

function ents.Derive(name)
	return love.filesystem.load(ents.objpath .. name .. ".lua") ()
end

function ents.Create(name,x,y)
	if not x then
		x=0
	end
	if not y then
		y=0
	end
	
	if register[name] then
		id = id + 1
		local ent = register[name] ()
		num = math.random(0, 400)
		if num <= 200 then
			ent:load("tree")
		else
			ent:load("tree2")
		end
		ent:setPos(x,y)
		ent.id=id
		ents.objects[#ents.objects + 1] = ent
		return ents.objects[#ents.objects]
	else
		print("Error: Entity " .. name .. " does not exist!")
		return false;
	end
end

function ents.Destroy(id)
	if ents.objects[id] then
		if ents.objects[id].Die then
			ents.objects[id].x = math.random(0, 736)
			ents.objects[id].y = math.random(664, 1164)
		end
	end
end

function ents:update(dt)
	for i, ent in pairs(ents.objects) do
		if ent.update then
			ent:update(dt)
		end
	end
end

function ents:draw()
	for i, ent in pairs(ents.objects) do
		if ent.draw then
			ent:draw()
		end
	end
end